var protocol,CONNECT_TIMEOUT=15e3;class XpraProtocolWorkerHost{constructor(){this.worker=null,this.packet_handler=null}open(uri){this.worker?this.worker.postMessage({c:"o",u:uri}):(this.worker=new Worker("js/Protocol.js"),this.worker.addEventListener("message",e=>{var data=e.data;switch(data.c){case"r":this.worker.postMessage({c:"o",u:uri});break;case"p":this.packet_handler&&this.packet_handler(data.p);break;case"l":this.log(data.t);break;default:this.error("got unknown command from worker"),this.error(e.data)}},!1))}close=function(){this.worker.postMessage({c:"c"})};terminate=function(){this.worker.postMessage({c:"t"})};send=function(packet){this.worker.postMessage({c:"s",p:packet})};set_packet_handler=function(callback){this.packet_handler=callback};set_cipher_in=function(caps,key){this.worker.postMessage({c:"z",p:caps,k:key})};set_cipher_out=function(caps,key){this.worker.postMessage({c:"x",p:caps,k:key})}}class XpraProtocol{constructor(){this.verify_connected_timer=0,this.is_worker=!1,this.packet_handler=null,this.websocket=null,this.raw_packets=[],this.cipher_in=null,this.cipher_in_block_size=null,this.cipher_out=null,this.rQ=[],this.sQ=[],this.mQ=[],this.header=[],this.process_interval=0}close_event_str(event){var code_mappings={1e3:"Normal Closure",1001:"Going Away",1002:"Protocol Error",1003:"Unsupported Data",1004:"(For future)",1005:"No Status Received",1006:"Abnormal Closure",1007:"Invalid frame payload data",1008:"Policy Violation",1009:"Message too big",1010:"Missing Extension",1011:"Internal Error",1012:"Service Restart",1013:"Try Again Later",1014:"Bad Gateway",1015:"TLS Handshake"},message="";if(event.code)try{message+=void 0!==code_mappings[event.code]?`'${code_mappings[event.code]}' (${event.code})`:""+event.code,event.reason&&(message+=`: '${event.reason}'`)}catch(error){this.error("cannot parse websocket event:",error),message="unknown reason"}else message="unknown reason (no websocket error code)";return message}open(uri){var me=this;function handle(packet){me.packet_handler(packet)}this.raw_packets=[],this.rQ=[],this.sQ=[],this.mQ=[],this.header=[],this.websocket=null,this.verify_connected_timer=setTimeout(()=>handle(["error","connection timed out",0]),CONNECT_TIMEOUT);try{this.websocket=new WebSocket(uri,"binary")}catch(error){return void handle(["error",""+error,0])}this.websocket.binaryType="arraybuffer",this.websocket.addEventListener("open",function(){me.verify_connected_timer&&(clearTimeout(me.verify_connected_timer),me.verify_connected_timer=0),handle(["open"])}),this.websocket.addEventListener("close",event=>handle(["close",me.close_event_str(event)])),this.websocket.onerror=event=>handle(["error",me.close_event_str(event),event.code||0]),this.websocket.onmessage=function(e){me.rQ.push(new Uint8Array(e.data)),setTimeout(function(){me.process_receive_queue()},this.process_interval)}}close(){this.websocket&&(this.websocket.onopen=null,this.websocket.onclose=null,this.websocket.onerror=null,this.websocket.onmessage=null,this.websocket.close(),this.websocket=null)}protocol_error(message){this.error("protocol error:",message),this.websocket.onopen=null,this.websocket.onclose=null,this.websocket.onerror=null,this.websocket.onmessage=null,this.header=[],this.rQ=[],this.packet_handler(["close",message])}process_receive_queue(){for(;this.websocket&&this.do_process_receive_queue(););}error(){console.error.apply(console,arguments)}log(){console.log.apply(console,arguments)}do_process_receive_queue(){if(this.header.length<8&&0<this.rQ.length){for(;this.header.length<8&&0<this.rQ.length;){var slice=this.rQ[0],needed=8-this.header.length,n=Math.min(needed,slice.length);this.header.push(...slice.subarray(0,n)),slice.length>needed?this.rQ[0]=slice.subarray(n):this.rQ.shift()}if(80!==this.header[0]){var message="invalid packet header format: "+this.header[0];if(1<this.header.length){var p,hex="";for(p of this.header){var v=p.toString(16);hex+=v.length<2?"0"+v:v}message+=": 0x"+hex}return this.protocol_error(message),!1}}if(this.header.length<8)return!1;var message=this.header[1],proto_crypto=2&message;if(proto_crypto&&(message&=-3),8&message&&(message&=-9),!(1<message&&16!=message)){var level=this.header[2];if(32&level)return this.protocol_error("lzo compression is not supported"),!1;if(20<=(index=this.header[3]))return this.protocol_error("invalid packet index: "+index),!1;var packet_data,inflated,packet_size=[4,5,6,7].reduce((accumulator,value)=>256*accumulator+this.header[value],0),padding=0,rsize=(proto_crypto&&0<this.cipher_in_block_size&&(packet_size+=padding=this.cipher_in_block_size-packet_size%this.cipher_in_block_size),this.rQ.reduce((accumulator,value)=>accumulator+value.length,0));if(rsize<packet_size)return!1;if(this.header=[],this.rQ[0].length==packet_size)packet_data=this.rQ.shift();else for(packet_data=new Uint8Array(packet_size),rsize=0;rsize<packet_size;){needed=packet_size-rsize;(slice=this.rQ[0]).length>needed?(packet_data.set(slice.subarray(0,needed),rsize),rsize+=needed,this.rQ[0]=slice.subarray(needed)):(packet_data.set(slice,rsize),rsize+=slice.length,this.rQ.shift())}if(proto_crypto){this.cipher_in.update(forge.util.createBuffer(Utilities.Uint8ToString(packet_data)));proto_crypto=this.cipher_in.output.getBytes();if(!proto_crypto||proto_crypto.length<packet_size-padding)return this.error("error decrypting packet using",this.cipher_in),proto_crypto.length<packet_size-padding?this.error(` expected ${packet_size-padding} bytes, but got `+proto_crypto.length):this.error(" decrypted:",proto_crypto),this.raw_packets=[],0<this.rQ.length;packet_data=Utilities.StringToUint8(proto_crypto.slice(0,packet_size-padding))}if(0!=level){if(16&level)inflated=lz4.decode(packet_data);else{if(!(64&level))throw"zlib is no longer supported";inflated=new Uint8Array(BrotliDecode(packet_data))}packet_data=inflated}if(0<index){if(this.raw_packets[index]=packet_data,4<=this.raw_packets.length)return this.protocol_error("too many raw packets: "+this.raw_packets.length),!1}else{var packet=null;try{if(16!=message)throw 1==message?"rencode legacy mode is not supported, protocol flag: "+message:"invalid packet encoder flags "+message;for(var index in packet=rdecode(packet_data),this.raw_packets)packet[index]=this.raw_packets[index];this.raw_packets={}}catch(error){return this.error("error decoding packet",error),this.error("packet="+packet_data),this.error("protocol flags="+message),this.raw_packets=[],0<this.rQ.length}try{this.is_worker?(this.mQ[this.mQ.length]=packet,setTimeout(()=>this.process_message_queue(),this.process_interval)):this.packet_handler(packet)}catch(error){this.error(`error processing packet ${packet[0]}: `+error),this.error(" packet data: "+packet_data)}}return 0<this.rQ.length}this.protocol_error("we can't handle this protocol flag yet: "+message)}process_send_queue(){for(;0<this.sQ.length&&this.websocket;){var packet=this.sQ.shift();if(!packet)return;var proto_flags=16,bdata=null;try{bdata=rencode(packet)}catch(error){this.error("Error: failed to encode packet:",packet),this.error(error);continue}var input_data,payload_size=bdata.length,actual_size=(this.cipher_out&&(proto_flags|=2,packet=this.cipher_out_block_size-payload_size%this.cipher_out_block_size,input_data="string"==typeof bdata?bdata:Utilities.Uint8ToString(bdata),packet&&(input_data+=String.fromCharCode(packet).repeat(packet)),this.cipher_out.update(forge.util.createBuffer(input_data),"utf8"),bdata=this.cipher_out.output.getBytes()),bdata.length),packet_data=new Uint8Array(actual_size+8);packet_data[0]="P".charCodeAt(0),packet_data[1]=proto_flags,packet_data[2]=0;for(var index=packet_data[3]=0;index<4;index++)packet_data[7-index]=payload_size>>8*index&255;if("object"==typeof bdata&&bdata.constructor===Uint8Array)packet_data.set(bdata,8);else for(index=0;index<actual_size;index++)packet_data[8+index]=Utilities.ord(bdata[index]);this.websocket&&this.websocket.send(new Uint8Array(packet_data).buffer)}}process_message_queue(){for(;0<this.mQ.length;){var packet=this.mQ.shift();if(!packet)return;var raw_buffers=[];"draw"===packet[0]&&"buffer"in packet[7]?raw_buffers.push(packet[7].buffer):"sound-data"===packet[0]&&Object.hasOwn(packet[2],"buffer")&&raw_buffers.push(packet[2].buffer),postMessage({c:"p",p:packet},raw_buffers)}}send(packet){this.sQ[this.sQ.length]=packet,setTimeout(()=>this.process_send_queue(),this.process_interval)}set_packet_handler(callback){this.packet_handler=callback}set_cipher_in(caps,key){this.setup_cipher(caps,key,(cipher,block_size,secret,iv)=>{this.cipher_in_block_size=block_size,this.cipher_in=forge.cipher.createDecipher(cipher,secret),this.cipher_in.start({iv:iv})})}set_cipher_out(caps,key){this.setup_cipher(caps,key,(cipher,block_size,secret,iv)=>{this.cipher_out_block_size=block_size,this.cipher_out=forge.cipher.createCipher(cipher,secret),this.cipher_out.start({iv:iv})})}setup_cipher(caps,key,setup_function){if(!key)throw"missing encryption key";var cipher=caps.cipher||"AES";if("AES"!=cipher)throw`unsupported encryption specified: '${cipher}'`;var key_salt=caps["cipher.key_salt"],iterations=("string"!=typeof key_salt&&(key_salt=String.fromCharCode.apply(null,key_salt)),caps["cipher.key_stretch_iterations"]);if(iterations<0)throw"invalid number of iterations: "+iterations;var key_size=caps["cipher.key_size"]||32;if(![32,24,16].includes(key_size))throw`invalid key size '${key_size}'`;var key_stretch=caps["cipher.key_stretch"]||"PBKDF2";if("PBKDF2"!=key_stretch.toUpperCase())throw"invalid key stretching function "+key_stretch;key_stretch=(caps["cipher.key_hash"]||"SHA1").toLowerCase(),key=forge.pkcs5.pbkdf2(key,key_salt,iterations,key_size,key_stretch),key_salt=caps["cipher.mode"]||"CBC",iterations=0;if("CBC"==key_salt)iterations=32;else if(!["CFB","CTR"].includes(key_salt))throw`unsupported AES mode '${key_salt}'`;key_size=caps["cipher.iv"];if(!key_size)throw"missing IV";setup_function(cipher+"-"+key_salt,iterations,key,key_size)}}"object"==typeof window&&"object"==typeof document&&window.document===document||(importScripts("lib/lz4.js","lib/brotli_decode.js","lib/forge.js","lib/rencode.js","Utilities.js"),(protocol=new XpraProtocol).is_worker=!0,protocol.set_packet_handler(packet=>{var raw_buffer=[];"draw"===packet[0]&&Object.hasOwn(packet[7],"buffer")?(raw_buffer=packet[7].buffer,packet[7]=null):"send-file-chunk"===packet[0]&&Object.hasOwn(packet[3],"buffer")&&(raw_buffer=packet[3].buffer,packet[3]=null),postMessage({c:"p",p:packet},raw_buffer)},null),self.addEventListener("message",e=>{var data=e.data;switch(data.c){case"o":protocol.open(data.u);break;case"s":protocol.send(data.p);break;case"x":protocol.set_cipher_out(data.p,data.k);break;case"z":protocol.set_cipher_in(data.p,data.k);break;case"c":protocol.close();break;case"t":self.close();break;default:postMessage({c:"l",t:"got unknown command from host"})}},!1),postMessage({c:"r"}));